package me.Demon.DemonLevels.util;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;
import java.math.BigInteger;

public class ScriptEngineAPI {

    public static BigInteger getExpFormat(String ExpFormat) {
        // 检查表达式是否包含无效字符
        if (isValidExpression(ExpFormat)) {
            try {
                // 创建一个脚本引擎管理器
                ScriptEngineManager manager = new ScriptEngineManager();
                // 获取一个 JavaScript 引擎实例
                ScriptEngine engine = manager.getEngineByName("JavaScript");
                // 执行表达式并获取结果
                Object result = engine.eval(ExpFormat);
                // 输出结果
                return new BigInteger(result.toString());
            } catch (ScriptException e) {
                e.printStackTrace();
            }
        }
        return new BigInteger("0");
    }

    private static boolean isValidExpression(String expression) {
        return expression.matches("[0-9\\s+\\-*/()]+");
    }

}
