package me.Demon.DemonLevels.listener;

import me.Demon.DemonLevels.Main;
import me.Demon.DemonLevels.event.UpLevelEvant;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

public class UpgradePrompt implements Listener {

    @EventHandler
    public void onUpLevel(UpLevelEvant e){
        // 获取玩家的新等级
        int level = e.getLevel();
        // 检查玩家的等级是否是5的倍数
        if (level % 5 == 0) {
            // 获取触发事件的玩家
            Player p = e.getPlayer();
            // 获取玩家名称
            String name = p.getName();
            // 从配置中获取当前等级对应的前缀
            String prefix = Main.configYml.getRankTitle(level);
            // 广播消息，通知所有玩家该玩家达到新的境界
            Bukkit.broadcastMessage("§f[§c§l公告§f] §a玩家§e" + name + "§a境界成功达到了 §7[" + prefix + "§7]");
            // 获取玩家对象
            Player player = Bukkit.getPlayer(name);
            if(player == null){return;}
            // 发送消息到玩家，提示他们可以去找觉醒台
            player.sendMessage("§f[§c提示§f] §a您可以前往§e[学院]§a找到觉醒台进行武魂觉醒.");
        }
    }

}
